=== modified file 'plugin/innobase/dict/dict0dict.cc'
--- plugin/innobase/dict/dict0dict.cc	2010-12-26 21:08:54 +0000
+++ plugin/innobase/dict/dict0dict.cc	2011-02-04 22:30:00 +0000
@@ -56,6 +56,8 @@
 
 #include <ctype.h>
 
+#include <drizzled/session.h>
+
 /** the dictionary system */
 UNIV_INTERN dict_sys_t*	dict_sys	= NULL;
 
@@ -3836,7 +3838,7 @@
 	heap = mem_heap_create(10000);
 
 	err = dict_create_foreign_constraints_low(
-		trx, heap, innobase_get_charset(trx->mysql_thd), str, name,
+		trx, heap, trx->session()->charset(), str, name,
 		reject_fks);
 
 	mem_heap_free(heap);
@@ -3874,13 +3876,13 @@
 	ut_a(trx);
 	ut_a(trx->mysql_thd);
 
-	cs = innobase_get_charset(trx->mysql_thd);
+	cs = trx->session()->charset();
 
 	*n = 0;
 
 	*constraints_to_drop = static_cast<const char **>(mem_heap_alloc(heap, 1000 * sizeof(char*)));
 
-        ptr = innobase_get_stmt(trx->mysql_thd, &len);
+        ptr= trx->session()->getQueryStringCopy(len);
 
         str = dict_strip_comments(ptr, len);
 

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2011-02-04 18:43:13 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2011-02-04 22:30:00 +0000
@@ -114,7 +114,6 @@
 #include "ha_prototypes.h"
 #include "ut0mem.h"
 #include "ibuf0ibuf.h"
-#include "mysql_addons.h"
 
 #include "ha_innodb.h"
 #include "data_dictionary.h"
@@ -1263,18 +1262,6 @@
   my_casedn_str(system_charset_info, a);
 }
 
-/**********************************************************************//**
-Determines the connection character set.
-@return connection character set */
-UNIV_INTERN
-const void*
-innobase_get_charset(
-/*=================*/
-  drizzled::Session *mysql_session)  /*!< in: MySQL thread handle */
-{
-  return mysql_session->charset();
-}
-
 UNIV_INTERN
 bool
 innobase_isspace(
@@ -1284,27 +1271,6 @@
   return my_isspace(static_cast<const CHARSET_INFO *>(cs), char_to_test);
 }
 
-UNIV_INTERN
-int
-innobase_fast_mutex_init(
-        os_fast_mutex_t*        fast_mutex)
-{
-  return pthread_mutex_init(fast_mutex, MY_MUTEX_INIT_FAST);
-}
-
-/**********************************************************************//**
-Determines the current SQL statement.
-@return        SQL statement string */
-UNIV_INTERN
-const char*
-innobase_get_stmt(
-/*==============*/
-       drizzled::Session *session,        /*!< in: MySQL thread handle */
-       size_t* length)         /*!< out: length of the SQL statement */
-{
-  return session->getQueryStringCopy(*length);
-}
-
 #if defined (__WIN__) && defined (MYSQL_DYNAMIC_PLUGIN)
 /*******************************************************************//**
 Map an OS error to an errno value. The OS error number is stored in
@@ -6246,7 +6212,7 @@
     }
   }
 
-  stmt = innobase_get_stmt(&session, &stmt_len);
+  stmt= session.getQueryStringCopy(stmt_len);
 
   if (stmt) {
     string generated_create_table;

=== modified file 'plugin/innobase/handler/internal_dictionary.cc'
--- plugin/innobase/handler/internal_dictionary.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/handler/internal_dictionary.cc	2011-02-04 22:30:00 +0000
@@ -51,7 +51,6 @@
 #include "ha_prototypes.h"
 #include "ut0mem.h"
 #include "ibuf0ibuf.h"
-#include "mysql_addons.h"
 #include "handler0vars.h"
 
 using namespace drizzled;

=== removed file 'plugin/innobase/handler/mysql_addons.cc'
--- plugin/innobase/handler/mysql_addons.cc	2011-02-04 10:34:34 +0000
+++ plugin/innobase/handler/mysql_addons.cc	1970-01-01 00:00:00 +0000
@@ -1,54 +0,0 @@
-/*****************************************************************************
-
-Copyright (C) 2007, 2009, Innobase Oy. All Rights Reserved.
-
-This program is free software; you can redistribute it and/or modify it under
-the terms of the GNU General Public License as published by the Free Software
-Foundation; version 2 of the License.
-
-This program is distributed in the hope that it will be useful, but WITHOUT
-ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License along with
-this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
-St, Fifth Floor, Boston, MA 02110-1301 USA
-
-*****************************************************************************/
-
-/**************************************************//**
-@file handler/mysql_addons.cc
-This file contains functions that need to be added to
-MySQL code but have not been added yet.
-
-Whenever you add a function here submit a MySQL bug
-report (feature request) with the implementation. Then
-write the bug number in the comment before the
-function in this file.
-
-When MySQL commits the function it can be deleted from
-here. In a perfect world this file exists but is empty.
-
-Created November 07, 2007 Vasil Dimov
-*******************************************************/
-
-#ifndef MYSQL_SERVER
-#define MYSQL_SERVER
-#endif /* MYSQL_SERVER */
-
-#include "config.h"
-
-#include "mysql_addons.h"
-#include "univ.i"
-#include "drizzled/session.h"
-
-/**
-  Return the session id of a user session
-  @param pointer to Session object
-  @return session's id
-*/
-unsigned long session_get_thread_id(const drizzled::Session *session)
-{
-  return (unsigned long) session->getSessionId();
-}
-

=== modified file 'plugin/innobase/handler/replication_dictionary.cc'
--- plugin/innobase/handler/replication_dictionary.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/handler/replication_dictionary.cc	2011-02-04 22:30:00 +0000
@@ -52,7 +52,6 @@
 #include "ha_prototypes.h"
 #include "ut0mem.h"
 #include "ibuf0ibuf.h"
-#include "mysql_addons.h"
 #include "create_replication.h"
 #include "read_replication.h"
 #include "handler0vars.h"

=== modified file 'plugin/innobase/handler/replication_log.cc'
--- plugin/innobase/handler/replication_log.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/handler/replication_log.cc	2011-02-04 22:30:00 +0000
@@ -59,7 +59,6 @@
 #include "ha_prototypes.h"
 #include "ut0mem.h"
 #include "ibuf0ibuf.h"
-#include "mysql_addons.h"
 
 using namespace std;
 using namespace drizzled;

=== removed file 'plugin/innobase/include/mysql_addons.h'
--- plugin/innobase/include/mysql_addons.h	2011-02-04 10:34:34 +0000
+++ plugin/innobase/include/mysql_addons.h	1970-01-01 00:00:00 +0000
@@ -1,66 +0,0 @@
-/*****************************************************************************
-
-Copyright (C) 2007, 2009, Innobase Oy. All Rights Reserved.
-
-This program is free software; you can redistribute it and/or modify it under
-the terms of the GNU General Public License as published by the Free Software
-Foundation; version 2 of the License.
-
-This program is distributed in the hope that it will be useful, but WITHOUT
-ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License along with
-this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
-St, Fifth Floor, Boston, MA 02110-1301 USA
-
-*****************************************************************************/
-
-/**************************************************//**
-@file include/mysql_addons.h
-This file contains functions that need to be added to
-MySQL code but have not been added yet.
-
-Whenever you add a function here submit a MySQL bug
-report (feature request) with the implementation. Then
-write the bug number in the comment before the
-function in this file.
-
-When MySQL commits the function it can be deleted from
-here. In a perfect world this file exists but is empty.
-
-Created November 07, 2007 Vasil Dimov
-*******************************************************/
-
-#if defined(BUILD_DRIZZLE)
-#if !defined(__cplusplus)
-#include <stdbool.h>
-#endif
-
-namespace drizzled { class Session; }
-
-/**
- *
-  Return the thread id of a user thread
-
-  @param session  user thread connection handle
-  @return  thread id
-*/
-unsigned long session_get_thread_id(const drizzled::Session *session);
-
-/**
-  Check if a user thread is running a non-transactional update
-  @param session  user thread
-  @retval 0 the user thread is not running a non-transactional update
-  @retval 1 the user thread is running a non-transactional update
-*/
-int session_non_transactional_update(const drizzled::Session *session);
-
-/**
-  Mark transaction to rollback and mark error as fatal to a sub-statement.
-  @param  session   Thread handle
-  @param  all   TRUE <=> rollback main transaction.
-*/
-void session_mark_transaction_to_rollback(drizzled::Session *session, bool all);
-
-#endif

=== modified file 'plugin/innobase/include/trx0trx.h'
--- plugin/innobase/include/trx0trx.h	2011-02-04 08:41:48 +0000
+++ plugin/innobase/include/trx0trx.h	2011-02-04 22:30:00 +0000
@@ -707,6 +707,15 @@
 	/*------------------------------*/
 	char detailed_error[256];	/*!< detailed error message for last
 					error, or empty. */
+
+        inline drizzled::Session *session()
+        {
+          return mysql_thd;
+        }
+        inline drizzled::Session *session() const
+        {
+          return mysql_thd;
+        }
 };
 
 #define TRX_MAX_N_THREADS	32	/* maximum number of

=== modified file 'plugin/innobase/os/os0sync.cc'
--- plugin/innobase/os/os0sync.cc	2010-12-26 00:22:34 +0000
+++ plugin/innobase/os/os0sync.cc	2011-02-04 22:30:00 +0000
@@ -877,7 +877,7 @@
 
 	InitializeCriticalSection((LPCRITICAL_SECTION) fast_mutex);
 #else
-	ut_a(0 == innobase_fast_mutex_init(fast_mutex));
+	ut_a(0 == pthread_mutex_init(fast_mutex, NULL));
 #endif
 	if (UNIV_LIKELY(os_sync_mutex_inited)) {
 		/* When creating os_sync_mutex itself (in Unix) we cannot

=== modified file 'plugin/innobase/plugin.am'
--- plugin/innobase/plugin.am	2011-01-18 17:54:23 +0000
+++ plugin/innobase/plugin.am	2011-02-04 22:30:00 +0000
@@ -100,7 +100,6 @@
                  plugin/innobase/include/mtr0mtr.h \
                  plugin/innobase/include/mtr0mtr.ic \
                  plugin/innobase/include/mtr0types.h \
-                 plugin/innobase/include/mysql_addons.h \
                  plugin/innobase/include/os0file.h \
 		 plugin/innobase/include/os0file.ic \
                  plugin/innobase/include/os0proc.h \

=== modified file 'plugin/innobase/plugin.ini'
--- plugin/innobase/plugin.ini	2010-12-18 04:43:40 +0000
+++ plugin/innobase/plugin.ini	2011-02-04 22:30:00 +0000
@@ -18,13 +18,13 @@
 title=InnoDB Storage Engine
 description=Transactional Tables using InnoDB
 load_by_default=yes
-sources=handler/ha_innodb.cc
+sources=
+  handler/data_dictionary.cc
+  handler/ha_innodb.cc
   handler/handler0alter.cc
-  handler/data_dictionary.cc
   handler/internal_dictionary.cc
-  handler/mysql_addons.cc
+  handler/replication_dictionary.cc
   handler/replication_log.cc
-  handler/replication_dictionary.cc
 cflags=${NO_SHADOW} -I$(top_srcdir)/plugin/innobase/include -DBUILD_DRIZZLE
 cxxflags=${NO_SHADOW} -I$(top_srcdir)/plugin/innobase/include -DBUILD_DRIZZLE
 libs=plugin/innobase/libinnobase.la

=== modified file 'plugin/innobase/trx/trx0i_s.cc'
--- plugin/innobase/trx/trx0i_s.cc	2010-12-26 21:16:41 +0000
+++ plugin/innobase/trx/trx0i_s.cc	2011-02-04 22:30:00 +0000
@@ -41,8 +41,6 @@
 # include <mysql/plugin.h>
 #endif
 
-#include "mysql_addons.h"
-
 #include "buf0buf.h"
 #include "dict0dict.h"
 #include "ha0storage.h"
@@ -64,6 +62,8 @@
 #include "ut0mem.h"
 #include "ut0ut.h"
 
+#include <drizzled/session.h>
+
 /** Initial number of rows in the table cache */
 #define TABLE_CACHE_INITIAL_ROWSNUM	1024
 
@@ -509,8 +509,8 @@
 		goto thd_done;
 	}
 
-	row->trx_mysql_thread_id = session_get_thread_id(trx->mysql_thd);
-	stmt = innobase_get_stmt(trx->mysql_thd, &stmt_len);
+	row->trx_mysql_thread_id = trx->session()->getSessionId();
+        stmt= trx->mysql_thd->getQueryStringCopy(stmt_len);
 
 	if (stmt != NULL) {
 

